| The Gaudi Framework v30r0 (c919700c)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
Gaudi::Functional::details::insert_t Struct Reference

`#include <GaudiAlg/FunctionalDetails.h>`

## Public Types
template<typename Container >
using | c_remove_ptr_t = std::remove_pointer_t< typename Container::value_type >

## Public Member Functions
template<typename Container , typename Value >
auto | operator() (Container &c, Value &&v) const -> decltype(c.push_back(v))
template<typename Container , typename Value >
auto | operator() (Container &c, Value &&v) const -> decltype(c.insert(v))
template<typename Container , typename = std::enable_if_t<std::is_pointer<typename Container::value_type>::value>>
auto | operator() (Container &c, c_remove_ptr_t< Container > &&v) const
template<typename Container , typename Value >
void | operator() (Container &c, boost::optional< Value > &&v) const

## Detailed Description

Definition at line 137 of file FunctionalDetails.h.

## Member Typedef Documentation

template<typename Container >

using Gaudi::Functional::details::insert_t::c_remove_ptr_t = std::remove_pointer_t<typename Container::value_type>

Definition at line 140 of file FunctionalDetails.h.

## Member Function Documentation

template<typename Container , typename Value >

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | Value && | v
| ) |  | const -> decltype( c.push_back( v ) )
| inline

Definition at line 143 of file FunctionalDetails.h.

144 {
145 return c.push_back( std::forward<Value>( v ) );
146 }
gaudirun.c
c
Definition: gaudirun.py:407
template<typename Container , typename Value >

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | Value && | v
| ) |  | const -> decltype( c.insert( v ) )
| inline

Definition at line 149 of file FunctionalDetails.h.

150 {
151 return c.insert( std::forward<Value>( v ) );
152 }
gaudirun.c
c
Definition: gaudirun.py:407
template<typename Container , typename = std::enable_if_t<std::is_pointer<typename Container::value_type>::value>>

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | c_remove_ptr_t< Container > && | v
| ) |  | const
| inline

Definition at line 157 of file FunctionalDetails.h.

158 {
159 return operator()( c, new c_remove_ptr_t<Container>{std::move( v )} );
160 }
gaudirun.c
c
Definition: gaudirun.py:407
Gaudi::Functional::details::insert_t::operator()
auto operator()(Container &c, Value &&v) const -> decltype(c.push_back(v))
Definition: FunctionalDetails.h:143
std::move
T move(T...args)
template<typename Container , typename Value >

void Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | boost::optional< Value > && | v
| ) |  | const
| inline

Definition at line 163 of file FunctionalDetails.h.

164 {
165 if ( v ) operator()( c, std::move( *v ) );
166 }
gaudirun.c
c
Definition: gaudirun.py:407
Gaudi::Functional::details::insert_t::operator()
auto operator()(Container &c, Value &&v) const -> decltype(c.push_back(v))
Definition: FunctionalDetails.h:143
std::move
T move(T...args)

The documentation for this struct was generated from the following file:

- GaudiAlg/GaudiAlg/FunctionalDetails.h